<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: VTA_ProductoFinalDet.xml */
/* Generado: 2021-02-23 17:19:34 */

/* Mantenimiento de los registros de la tabla VTA_ProductoFinalDet */
abstract class BaseVTA_ProductoFinalDetDP extends VTA_ProductoFinalDetBV
{
    /* Constructor ( Establece los valores desde un objeto VTA_ProductoFinalDetBN ) */
    public function __construct( VTA_ProductoFinalDetBN $o_VTA_ProductoFinalDetBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_VTA_ProductoFinalDetBN ) )
        {
            $this->setByBN( $o_VTA_ProductoFinalDetBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto VTA_ProductoFinalDetBN */
    public function setByBN( VTA_ProductoFinalDetBN $o_VTA_ProductoFinalDetBN )
    {
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getProFinalDetId() ) )
        {
            $this->setProFinalDetId( $o_VTA_ProductoFinalDetBN->getProFinalDetId() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getProFinalId() ) )
        {
            $this->setProFinalId( $o_VTA_ProductoFinalDetBN->getProFinalId() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getOrdenId() ) )
        {
            $this->setOrdenId( $o_VTA_ProductoFinalDetBN->getOrdenId() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getSecuencia() ) )
        {
            $this->setSecuencia( $o_VTA_ProductoFinalDetBN->getSecuencia() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getIdItem() ) )
        {
            $this->setIdItem( $o_VTA_ProductoFinalDetBN->getIdItem() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getIdAlmacen() ) )
        {
            $this->setIdAlmacen( $o_VTA_ProductoFinalDetBN->getIdAlmacen() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getIdUnidad() ) )
        {
            $this->setIdUnidad( $o_VTA_ProductoFinalDetBN->getIdUnidad() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getDetalleDescripcion() ) )
        {
            $this->setDetalleDescripcion( $o_VTA_ProductoFinalDetBN->getDetalleDescripcion() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getCantidad() ) )
        {
            $this->setCantidad( $o_VTA_ProductoFinalDetBN->getCantidad() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getCantidadRecibida() ) )
        {
            $this->setCantidadRecibida( $o_VTA_ProductoFinalDetBN->getCantidadRecibida() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getPesoUnitario() ) )
        {
            $this->setPesoUnitario( $o_VTA_ProductoFinalDetBN->getPesoUnitario() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getPesoTotal() ) )
        {
            $this->setPesoTotal( $o_VTA_ProductoFinalDetBN->getPesoTotal() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getPrecioUnitarioAlq() ) )
        {
            $this->setPrecioUnitarioAlq( $o_VTA_ProductoFinalDetBN->getPrecioUnitarioAlq() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getImpuestoUnitarioAlq() ) )
        {
            $this->setImpuestoUnitarioAlq( $o_VTA_ProductoFinalDetBN->getImpuestoUnitarioAlq() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getPrecioUnitarioConIGVAlq() ) )
        {
            $this->setPrecioUnitarioConIGVAlq( $o_VTA_ProductoFinalDetBN->getPrecioUnitarioConIGVAlq() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getMontoSubTotalAlq() ) )
        {
            $this->setMontoSubTotalAlq( $o_VTA_ProductoFinalDetBN->getMontoSubTotalAlq() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getImpuestoTotalAlq() ) )
        {
            $this->setImpuestoTotalAlq( $o_VTA_ProductoFinalDetBN->getImpuestoTotalAlq() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getTotalConIGVAlq() ) )
        {
            $this->setTotalConIGVAlq( $o_VTA_ProductoFinalDetBN->getTotalConIGVAlq() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getPrecioUnitarioVal() ) )
        {
            $this->setPrecioUnitarioVal( $o_VTA_ProductoFinalDetBN->getPrecioUnitarioVal() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getImpuestoUnitarioVal() ) )
        {
            $this->setImpuestoUnitarioVal( $o_VTA_ProductoFinalDetBN->getImpuestoUnitarioVal() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getPrecioUnitarioConIGVVal() ) )
        {
            $this->setPrecioUnitarioConIGVVal( $o_VTA_ProductoFinalDetBN->getPrecioUnitarioConIGVVal() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getMontoSubTotalVal() ) )
        {
            $this->setMontoSubTotalVal( $o_VTA_ProductoFinalDetBN->getMontoSubTotalVal() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getImpuestoTotalVal() ) )
        {
            $this->setImpuestoTotalVal( $o_VTA_ProductoFinalDetBN->getImpuestoTotalVal() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getTotalConIGVVal() ) )
        {
            $this->setTotalConIGVVal( $o_VTA_ProductoFinalDetBN->getTotalConIGVVal() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_VTA_ProductoFinalDetBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_VTA_ProductoFinalDetBN->getFechaCreacion() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_VTA_ProductoFinalDetBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_VTA_ProductoFinalDetBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_VTA_ProductoFinalDetBN->getFechaModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_VTA_ProductoFinalDetFN = new VTA_ProductoFinalDetFN();
        $o_VTA_ProductoFinalDetBN = $o_VTA_ProductoFinalDetFN->selectByPk( $this->getProFinalDetId() );
        if ( is_null( $o_VTA_ProductoFinalDetBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO VTA_ProductoFinalDet ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getProFinalDetId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ProFinalDetId";
                $s_SQLQuery2 .= $s_Separator."".$this->getProFinalDetId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProFinalId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ProFinalId";
                $s_SQLQuery2 .= $s_Separator."".$this->getProFinalId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."OrdenId";
                $s_SQLQuery2 .= $s_Separator."".$this->getOrdenId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSecuencia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Secuencia";
                $s_SQLQuery2 .= $s_Separator."'".$this->getSecuencia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdAlmacen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUnidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUnidad";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdUnidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDetalleDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DetalleDescripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDetalleDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Cantidad";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadRecibida() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadRecibida";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadRecibida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPesoUnitario() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PesoUnitario";
                $s_SQLQuery2 .= $s_Separator."".$this->getPesoUnitario()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPesoTotal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PesoTotal";
                $s_SQLQuery2 .= $s_Separator."".$this->getPesoTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioAlq() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioAlq";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImpuestoUnitarioAlq() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ImpuestoUnitarioAlq";
                $s_SQLQuery2 .= $s_Separator."".$this->getImpuestoUnitarioAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioConIGVAlq() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioConIGVAlq";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioConIGVAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoSubTotalAlq() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoSubTotalAlq";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoSubTotalAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImpuestoTotalAlq() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ImpuestoTotalAlq";
                $s_SQLQuery2 .= $s_Separator."".$this->getImpuestoTotalAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTotalConIGVAlq() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TotalConIGVAlq";
                $s_SQLQuery2 .= $s_Separator."".$this->getTotalConIGVAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioVal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioVal";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImpuestoUnitarioVal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ImpuestoUnitarioVal";
                $s_SQLQuery2 .= $s_Separator."".$this->getImpuestoUnitarioVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioConIGVVal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioConIGVVal";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioConIGVVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoSubTotalVal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MontoSubTotalVal";
                $s_SQLQuery2 .= $s_Separator."".$this->getMontoSubTotalVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImpuestoTotalVal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ImpuestoTotalVal";
                $s_SQLQuery2 .= $s_Separator."".$this->getImpuestoTotalVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTotalConIGVVal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TotalConIGVVal";
                $s_SQLQuery2 .= $s_Separator."".$this->getTotalConIGVVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE VTA_ProductoFinalDet SET ";
            $s_Separator = "";
            if ( !is_null( $this->getProFinalId() ) )
            {
                $s_SQLQuery .= $s_Separator."ProFinalId = ".$this->getProFinalId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenId() ) )
            {
                $s_SQLQuery .= $s_Separator."OrdenId = ".$this->getOrdenId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSecuencia() ) )
            {
                $s_SQLQuery .= $s_Separator."Secuencia = '".$this->getSecuencia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdAlmacen() ) )
            {
                $s_SQLQuery .= $s_Separator."IdAlmacen = '".$this->getIdAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUnidad() ) )
            {
                $s_SQLQuery .= $s_Separator."IdUnidad = ".$this->getIdUnidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDetalleDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."DetalleDescripcion = '".$this->getDetalleDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidad() ) )
            {
                $s_SQLQuery .= $s_Separator."Cantidad = ".$this->getCantidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadRecibida() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadRecibida = ".$this->getCantidadRecibida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPesoUnitario() ) )
            {
                $s_SQLQuery .= $s_Separator."PesoUnitario = ".$this->getPesoUnitario()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPesoTotal() ) )
            {
                $s_SQLQuery .= $s_Separator."PesoTotal = ".$this->getPesoTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioAlq() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioAlq = ".$this->getPrecioUnitarioAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImpuestoUnitarioAlq() ) )
            {
                $s_SQLQuery .= $s_Separator."ImpuestoUnitarioAlq = ".$this->getImpuestoUnitarioAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioConIGVAlq() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioConIGVAlq = ".$this->getPrecioUnitarioConIGVAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoSubTotalAlq() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoSubTotalAlq = ".$this->getMontoSubTotalAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImpuestoTotalAlq() ) )
            {
                $s_SQLQuery .= $s_Separator."ImpuestoTotalAlq = ".$this->getImpuestoTotalAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTotalConIGVAlq() ) )
            {
                $s_SQLQuery .= $s_Separator."TotalConIGVAlq = ".$this->getTotalConIGVAlq()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioVal() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioVal = ".$this->getPrecioUnitarioVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImpuestoUnitarioVal() ) )
            {
                $s_SQLQuery .= $s_Separator."ImpuestoUnitarioVal = ".$this->getImpuestoUnitarioVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioConIGVVal() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioConIGVVal = ".$this->getPrecioUnitarioConIGVVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMontoSubTotalVal() ) )
            {
                $s_SQLQuery .= $s_Separator."MontoSubTotalVal = ".$this->getMontoSubTotalVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImpuestoTotalVal() ) )
            {
                $s_SQLQuery .= $s_Separator."ImpuestoTotalVal = ".$this->getImpuestoTotalVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTotalConIGVVal() ) )
            {
                $s_SQLQuery .= $s_Separator."TotalConIGVVal = ".$this->getTotalConIGVVal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  ProFinalDetId = ".$this->getProFinalDetId().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM VTA_ProductoFinalDet WHERE  ProFinalDetId = ".$this->getProFinalDetId().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>